#include <stdio.h>
#include <stdlib.h>
#include "factor.h"

int main( int argc , char* argv[] )
{
  if( argc<2 )
    {
      fprintf( stderr , "[ERROR] Need an argument\n" );
      return 1;
    }
  unsigned int n = atoi(argv[1] );
  unsigned int factors[20];
  int factorNum = factor( n , factors , sizeof(factors)/sizeof(unsigned int) );
  if( factorNum<0 ) printf( "Failed to factor: %ud\n" , n );
  else
    {
      printf( "Factors:" );
      for( int i=0 ; i<factorNum ; i++ ) printf( " %d" , factors[i] );
      printf( "\n" );
    }
  return 0;
}
