#include <stdio.h>
#include <stdlib.h>
#include "factor.h"

int testFactor( void )
{
  unsigned int f = 15;
  unsigned int trueFactors[] = { 5 , 3 };
  unsigned int factors[20];
  int factorNum = factor( f , factors , sizeof(factors)/sizeof(int) );
  if( factorNum!=sizeof(trueFactors)/sizeof(int) )
  {
    fprintf( stderr , "Wrong number of factors: %d != %d\n" , factorNum , sizeof(trueFactors)/sizeof(int) );
    return 1;
  }
  else for( int i=0 ; i<factorNum ; i++ ) if( trueFactors[i]!=factors[i] )
  {
     printf( "factor[%d] doesn't match: %d != %d\n" , i , factors[i] , trueFactors[i] );
     return 1;
  }
  return 0;
}

int main( void )
{
  if( testFactor() ) printf( "Failed unit test\n" );
  return 0;
}
